diff --git a/src/7z_fmt_plug.c b/src/7z_fmt_plug.c
index 82be3cbd85..35f4ffed83 100644
--- a/src/7z_fmt_plug.c
+++ b/src/7z_fmt_plug.c
@@ -222,7 +222,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) /* iv */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 	if (strlen(p) / 2 > len && strcmp(p+len*2, "0000000000000000"))
 		goto err;
@@ -243,7 +243,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if (strlen(p) / 2 != len)	/* validates data_len atoi() */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/androidfde_fmt_plug.c b/src/androidfde_fmt_plug.c
index 94909c2810..4aa10b3628 100644
--- a/src/androidfde_fmt_plug.c
+++ b/src/androidfde_fmt_plug.c
@@ -158,7 +158,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)	/* key */
 		goto err;
-	if(hexlenl(p) != keysize * 2)
+	if (hexlenl(p) != keysize * 2)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)	/* data */
 		goto err;
diff --git a/src/bitcoin_fmt_plug.c b/src/bitcoin_fmt_plug.c
index 0b05130f1a..26617e2d5d 100644
--- a/src/bitcoin_fmt_plug.c
+++ b/src/bitcoin_fmt_plug.c
@@ -157,7 +157,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if (strlen(p) != res || strlen(p) > SZ * 2) /* validates atoi() and cry_master */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) /* cry_salt_length (length of hex string) */
 		goto err;
@@ -168,7 +168,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if (strlen(p) != res || strlen(p) > SZ * 2) /* validates atoi() and cry_salt */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) /* cry_rounds */
 		goto err;
@@ -184,7 +184,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if (strlen(p) != res || strlen(p) > SZ * 2) /* validates atoi() and ckey */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL) /* public_key_length */
 		goto err;
@@ -195,7 +195,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if (strlen(p) != res || strlen(p) > SZ * 2) /* validates atoi() and public_key */
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 	MEM_FREE(keeptr);
 	return 1;
diff --git a/src/cloudkeychain_fmt_plug.c b/src/cloudkeychain_fmt_plug.c
index 6c5f5c3a9f..23bc2a82d1 100644
--- a/src/cloudkeychain_fmt_plug.c
+++ b/src/cloudkeychain_fmt_plug.c
@@ -165,9 +165,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)	/* iv */
 		goto err;
-	if (strlen(p) / 2 != len)	/* validates iv_len */
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) / 2 != len)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)	/* cryptext length */
 		goto err;
diff --git a/src/cq_fmt_plug.c b/src/cq_fmt_plug.c
index 4ca7c29aa6..f76dec0ee1 100644
--- a/src/cq_fmt_plug.c
+++ b/src/cq_fmt_plug.c
@@ -367,10 +367,8 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto Err;
 
 	p += 1;
-	if (strlen(p) != BINARY_SIZE * 2)
-		goto Err;
 
-	if (!ishex(p))
+	if (hexlenl(p)  != BINARY_SIZE * 2)
 		goto Err;
 
 	if ((p - q) >= SALT_SIZE || p <= q)
diff --git a/src/encfs_common_plug.c b/src/encfs_common_plug.c
index 480b07bc84..10be204fd1 100644
--- a/src/encfs_common_plug.c
+++ b/src/encfs_common_plug.c
@@ -46,7 +46,7 @@ int encfs_common_valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (res != hexlenl(p) / 2)
+	if (hexlenl(p)/2 != res)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* data length */
 		goto err;
@@ -57,7 +57,7 @@ int encfs_common_valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* data */
 		goto err;
-	if (res != hexlenl(p) / 2)
+	if (hexlenl(p)/2 != res)
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/gpg_fmt_plug.c b/src/gpg_fmt_plug.c
index 0b66fc1ba8..e57c25d8bb 100644
--- a/src/gpg_fmt_plug.c
+++ b/src/gpg_fmt_plug.c
@@ -331,7 +331,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* data */
 		goto err;
-	if (hexlenl(p) / 2 != res)
+	if (hexlenl(p) != res*2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* spec */
 		goto err;
@@ -368,7 +368,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv */
 		goto err;
-	if (hexlenl(p) != res * 2)
+	if (hexlenl(p) != res*2)
 		goto err;
 	/* handle "SPEC_SIMPLE" correctly */
 	if ((spec != 0 || usage == 255))
@@ -383,7 +383,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (hexlenl(p) != SALT_LENGTH * 2)
+	if (hexlenl(p) != SALT_LENGTH*2)
 		goto err;
 	/*
 	 * For some test vectors, there are no more fields,
@@ -418,7 +418,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 			goto err; // FIXME: warn if BIG_ENOUGH isn't big enough?
 		if ((p = strtokm(NULL, "*")) == NULL)
 			goto err;
-		if (hexlenl(p) != res * 2) /* validates res is a valid int */
+		if (hexlenl(p) != res*2)
 			goto err;
 		p = strtokm(NULL, "*");  /* NOTE, do not goto err if null, we WANT p nul if there are no fields */
 	}
diff --git a/src/kwallet_fmt_plug.c b/src/kwallet_fmt_plug.c
index 32d3a9ca51..e0f065055e 100644
--- a/src/kwallet_fmt_plug.c
+++ b/src/kwallet_fmt_plug.c
@@ -109,7 +109,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "$")) == NULL)	/* ct */
 		goto err;
-	if(hexlenl(p) / 2 != res)
+	if (hexlenl(p) != res*2)
 		goto err;
 	MEM_FREE(keeptr);
 	return 1;
diff --git a/src/lastpass_fmt_plug.c b/src/lastpass_fmt_plug.c
index a4008711e5..eaf299f50a 100644
--- a/src/lastpass_fmt_plug.c
+++ b/src/lastpass_fmt_plug.c
@@ -110,9 +110,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* hash */
 		goto err;
-	if (strlen(p) != 32)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != 32)
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/mongodb_fmt_plug.c b/src/mongodb_fmt_plug.c
index b893ed16b5..bad2f54c8f 100644
--- a/src/mongodb_fmt_plug.c
+++ b/src/mongodb_fmt_plug.c
@@ -122,16 +122,16 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	if (type == 0) {
 		if (!(ptr = strtokm(NULL, "$"))) /* hash */
 			goto error;
-		if (strlen(ptr) != 32 || !ishex(ptr))
+		if (hexlenl(ptr) != 32)
 			goto error;
 	} else {
 		if (!(ptr = strtokm(NULL, "$"))) /* salt */
 			goto error;
-		if (strlen(ptr) != 16 || !ishex(ptr))
+		if (hexlenl(ptr) != 16)
 			goto error;
 		if (!(ptr = strtokm(NULL, "$"))) /* hash */
 			goto error;
-		if (strlen(ptr) != 32 || !ishex(ptr))
+		if (hexlenl(ptr) != 32)
 			goto error;
 	}
 
diff --git a/src/nukedclan_fmt_plug.c b/src/nukedclan_fmt_plug.c
index f349f42bcb..7d2a10761c 100644
--- a/src/nukedclan_fmt_plug.c
+++ b/src/nukedclan_fmt_plug.c
@@ -134,9 +134,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	if (!(ptr = strtokm(ctcopy, "*")))
 		goto error;
 	/* HASHKEY is of fixed length 40 */
-	if (strlen(ptr) != 40)
-		goto error;
-	if(!ishex(ptr))
+	if(hexlenl(ptr) != 40)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*")))
 		goto error;
@@ -146,9 +144,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto error;
 	ptr += 2;
 	/* hash is of fixed length 32 */
-	if (strlen(ptr) != 32)
-		goto error;
-	if(!ishex(ptr))
+	if(hexlenl(ptr) != 32)
 		goto error;
 
 	MEM_FREE(keeptr);
diff --git a/src/o5logon_fmt_plug.c b/src/o5logon_fmt_plug.c
index 333ed00126..2bf7c1713b 100644
--- a/src/o5logon_fmt_plug.c
+++ b/src/o5logon_fmt_plug.c
@@ -124,15 +124,11 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	p = strtokm(ctcopy, "*"); /* ciphertext */
 	if(!p)
 		goto err;
-	if(strlen(p) != CIPHERTEXT_LENGTH * 2)
-		goto err;
-	if (!ishex(p))
+	if(hexlenu(p) != CIPHERTEXT_LENGTH * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if(strlen(p) != SALT_LENGTH * 2)
-		goto err;
-	if (!ishex(p))
+	if(hexlenu(p) != SALT_LENGTH * 2)
 		goto err;
 	MEM_FREE(keeptr);
 	return 1;
diff --git a/src/odf_fmt_plug.c b/src/odf_fmt_plug.c
index 8e4b85b484..9bd952f285 100644
--- a/src/odf_fmt_plug.c
+++ b/src/odf_fmt_plug.c
@@ -144,6 +144,9 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* checksum field (skipped) */
 		goto err;
+	res = hexlenl(p);
+	if (res != BINARY_SIZE * 2 && res != 64) // 2 hash types.
+		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv length */
 		goto err;
 	res = atoi(p);
@@ -151,9 +154,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* iv */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt length */
 		goto err;
@@ -164,9 +165,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* salt */
 		goto err;
-	if (strlen(p) != res * 2)
-		goto err;
-	if (!ishex(p))
+	if (hexlenl(p) != res * 2)
 		goto err;
 	if ((p = strtokm(NULL, "*")) == NULL)	/* something */
 		goto err;
@@ -175,7 +174,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	res = strlen(p);
 	if (res > 2048 || res & 1)
 		goto err;
-	if (!ishex(p))
+	if (!ishexlc(p))
 		goto err;
 
 	MEM_FREE(keeptr);
diff --git a/src/office_common_plug.c b/src/office_common_plug.c
index fd0569bc59..46ec40b9c7 100644
--- a/src/office_common_plug.c
+++ b/src/office_common_plug.c
@@ -121,19 +121,15 @@ static int valid(char *ciphertext, struct fmt_main *self, char *which)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* salt */
 		goto error;
-	if (strlen(ptr) != res * 2)
-		goto error;
-	if (!ishex(ptr))
+	if (hexlenl(ptr) != res * 2)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* encrypted verifier */
 		goto error;
-	if (!ishex(ptr))
-		goto error;
-	if (strlen(ptr) != 32)
+	if (hexlenl(ptr) != 32)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* encrypted verifier hash */
 		goto error;
-	if (!ishex(ptr))
+	if (!ishexlc(ptr))
 		goto error;
 	if (strlen(ptr) > 64)
 		goto error;
diff --git a/src/oldoffice_fmt_plug.c b/src/oldoffice_fmt_plug.c
index 7ef596b44c..1f65c1a489 100644
--- a/src/oldoffice_fmt_plug.c
+++ b/src/oldoffice_fmt_plug.c
@@ -144,15 +144,11 @@ static int valid(char *ciphertext, struct fmt_main *self)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* salt */
 		goto error;
-	if (strlen(ptr) != 32)
-		goto error;
-	if (!ishex(ptr))
+	if (hexlen(ptr) != 32)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* verifier */
 		goto error;
-	if (strlen(ptr) != 32)
-		goto error;
-	if (!ishex(ptr))
+	if (hexlen(ptr) != 32)
 		goto error;
 	if (!(ptr = strtokm(NULL, "*"))) /* verifier hash */
 		goto error;
diff --git a/src/pst_fmt_plug.c b/src/pst_fmt_plug.c
index cef7e061ed..a8ab380ebf 100644
--- a/src/pst_fmt_plug.c
+++ b/src/pst_fmt_plug.c
@@ -98,9 +98,7 @@ static int valid(char *ciphertext, struct fmt_main *self)
 	if (strncmp(ciphertext, "$pst$", 5))
 		return 0;
 	p = ciphertext + 5;
-	if (strlen(p) != BINARY_SIZE * 2)
-		return 0;
-	if (!ishex(p))
+	if (hexlenl(p) != BINARY_SIZE * 2)
 		return 0;
 	return 1;
 }
